Imports System.Web
Imports System.IO
Imports System.Net
Imports System.Security.Permissions
Imports Microsoft.Win32

'WARNING: This app is a thrown-together hack done in about 10 minutes. It worked for me the one time I used it.

'Import cases from CSV file as created by MS Excel. The columns in the excel spreadsheet I used are:
'The Project,Area,Title,Description,Hours
'I think that project and area should match exactly the definitions in the FB database.

'Note: Saving as CSV in excel will automatically escape any embedded "'s as shown below. Nice.
'Expects a file in EXACTLY this format:
'Iceberg,Dev Items,test,Description of the 'Item',10
'Iceberg,Dev Items,test2,22222,20
'Iceberg,Dev Items,test3,"333' '3'3 '3'"" "" 3rd Item, that I think is cool",30"

'Our workflow is to develop a detailed spec, then break the spec down into detailed work items.
'The work items usually end up in a table in Word, since it's easiest to edit this way. 
'Developers add detailed comments and add their estimates in Hours.
'Next this table is imported into excel, saved as CSV, then we run this app to import into FB.
'In FB, each area has a default developer assigned, so the work gets assigned this way.
'Once in FB, I select 'em all, convert to Features and schedule items where appropriate.
'And I fine-tune the work assignments to balance the workload among developers.
'
'The flow seems clunky, but it preserves the ease of editing and group sharing and input for as long
'as possible, then it's into FB, where it's actually DONE.
'
'The basis for this little app was the example code that comes with FB.
'
'Nice improvement:
'Read the first line of the CSV file for the actual FB Fields to use, and make the number of columns dynamic.
'
'Known Issues:
'No error checking. VERY little testing. Basically, it worked once for me, and I'm happy.
'
'This work is in the public domain. Go ahead and modify and improve. Please send me a copy of your improvements!
'rich@ingenius.com
'
Public Class Form1
    'LAME!!!!!!
    Dim rows(1000, 5) As String 'lame hard limit here.
    'LAME!!!!!!

    Dim row As Integer 'Current row of the file we're looking at. 0 based.
    Dim token As String 'token returned by FB. Needed for each case created.
    Dim loggedInNow As Boolean 'Boolean so we don't have to repeat the logon code for each case added.
    '
    ' CallRestAPIFiles submits an API request to the FogBugz api using the 
    ' multipart/form-data submission method (so you can add files)
    ' Don't forget to include nFileCount in your rgArgs collection if you are adding files.
    '
    Function CallRESTAPIFiles(ByVal sURL, ByVal rgArgs, ByVal rgFiles)

        Dim sBoundaryString = getRandomString(30)
        Dim sBoundary = "--" + sBoundaryString
        Dim encoding As New System.Text.ASCIIEncoding
        Dim utf8encoding As New System.Text.UTF8Encoding
        Dim http As System.Net.HttpWebRequest = System.Net.HttpWebRequest.Create(sURL)
        http.Method = "POST"
        http.AllowWriteStreamBuffering = True
        http.ContentType = "multipart/form-data; boundary=" & sBoundaryString

        Dim parts As New Collection

        '
        ' add all the normal arguments
        '
        Dim i ', j
        For Each i In rgArgs
            parts.Add(encoding.GetBytes(sBoundary & vbCrLf))
            parts.Add(encoding.GetBytes("Content-Type: text/plain; charset=""utf-8""" & vbCrLf))
            parts.Add(encoding.GetBytes("Content-Disposition: form-data; name=""" & i.key & """" & vbCrLf & vbCrLf))
            parts.Add(utf8encoding.GetBytes(i.value))
            parts.Add(encoding.GetBytes(vbCrLf))
        Next

        '
        ' add all the files
        'These fields hidden in the UI.
        'For Each j In rgFiles
        'parts.Add(encoding.GetBytes(sBoundary & vbCrLf))
        'parts.Add(encoding.GetBytes("Content-Disposition: form-data; name=""" & j("name") & """; filename=""" & j("filename") & """" & vbCrLf))
        'parts.Add(encoding.GetBytes("Content-Transfer-Encoding: base64" & vbCrLf))
        'parts.Add(encoding.GetBytes("Content-Type: " & j("contenttype") & vbCrLf & vbCrLf))
        'parts.Add(j("data"))
        'parts.Add(encoding.GetBytes(vbCrLf))
        'Next

        parts.Add(encoding.GetBytes(sBoundary & "--"))

        '
        ' calculate the content length
        '
        Dim part As Byte()
        Dim nContentLength = 0
        For Each part In parts
            nContentLength += part.Length
        Next
        http.ContentLength = nContentLength

        '
        ' write the post
        '
        Dim stream As System.IO.Stream
        stream = http.GetRequestStream
        For Each part In parts
            stream.Write(part, 0, part.Length)
        Next
        stream.Close()

        '
        ' read the result
        '
        Dim r As System.IO.Stream
        r = http.GetResponse.GetResponseStream
        Dim reader As New System.IO.StreamReader(r)
        CallRESTAPIFiles = reader.ReadToEnd()
        reader.Close()

    End Function
    Function ProcessFile()
        'The MyReader stuff is sample code from MSDN.
        Dim MyReader As New Microsoft.VisualBasic.FileIO.TextFieldParser(txtFile.Text)
        MyReader.TextFieldType = FileIO.FieldType.Delimited
        MyReader.SetDelimiters(",")
        Dim currentRow As String()
        Dim col As Integer
        row = 0
        Do While Not MyReader.EndOfData
            Try
                currentRow = MyReader.ReadFields()
                Dim currentField As String
                col = 0
                For Each currentField In currentRow
                    'MsgBox(currentField)
                    rows(row, col) = currentField
                    'txtSplit - hidden in the UI. Used to test while reading in the file and checking the splitting.
                    'txtSplit.Text &= "<field>" & rows(row, col) & "</field>"
                    col += 1
                Next
                row += 1
                'txtSplit.Text &= vbCrLf
            Catch ex As Microsoft.VisualBasic.FileIO.MalformedLineException
                MsgBox("Line " & ex.Message & _
                "is not valid and will be skipped.")
            End Try
        Loop
        lblLinesInFile.Text = row & " lines read"
        row = 0
        LoadRow(0)
    End Function

    Function LoadRow(ByVal r As Integer)
        txtProject.Text = rows(r, 0)
        txtArea.Text = rows(r, 1)
        txtTitle.Text = rows(r, 2)
        txtS.Text = rows(r, 3)
        txtHours.Text = rows(r, 4)
        txtRow.Text = r
        Me.Update()
    End Function
    Function Logon()
        '
        ' First we logon
        '
        Dim args As New Hashtable
        args.Add("cmd", "logon")
        args.Add("email", txtEmail.Text)
        args.Add("password", txtPassword.Text)

        Dim result As String = CallRESTAPIFiles(txtURL.Text, args, New Hashtable)
        Dim reader As New System.Xml.XmlTextReader(New System.IO.StringReader(result))
        Dim doc As New System.Xml.XPath.XPathDocument(reader)
        Dim nav As System.Xml.XPath.XPathNavigator = doc.CreateNavigator()
        token = nav.Evaluate("string(response/token)").ToString
        loggedInNow = True
        lblMsg.Text = result
    End Function
    Function AddItem()

        Dim args As New Hashtable
        Dim result As String
        If loggedInNow = False Then
            Logon()
        End If

        args.Clear()
        args.Add("cmd", "new")
        args.Add("token", token)
        args.Add("nFileCount", listFiles.Items.Count)
        'The following items come from the file we've read. It would be a nice improvement to load these titles
        'from the first line of the CSV file.
        args.Add("sProject", txtProject.Text)
        args.Add("sArea", txtArea.Text)
        args.Add("sTitle", txtTitle.Text)
        args.Add("sEvent", txtS.Text)
        args.Add("hrsCurrEst", txtHours.Text)

        'The following stuff isn't used in this app, but could be useful for someone in the future.
        Dim files As New Collection
        Dim file As String

        Dim ix
        For ix = 0 To listFiles.Items.Count - 1
            file = listFiles.Items(ix)
            Dim params As New Hashtable
            Dim contents As New System.Text.StringBuilder
            Dim fs As System.IO.FileStream = New System.IO.FileStream(file, IO.FileMode.Open)
            Dim br As New System.IO.BinaryReader(fs)
            params.Add("data", br.ReadBytes(fs.Length))
            params.Add("name", "File" & (ix + 1))
            params.Add("filename", file.Substring(file.LastIndexOf("\") + 1))
            params.Add("contenttype", GetMIMEType(file))
            files.Add(params)
            fs.Close()
        Next

        result = CallRESTAPIFiles(txtURL.Text, args, files)
        lblMsg.Text = result

    End Function


    Function getRandomString(ByVal nLength)
        Dim chars As String = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz"
        Dim s = ""
        Dim i
        For i = 0 To nLength - 1
            Dim rnum = Math.Floor(Rnd() * chars.length)
            s = s & chars.Substring(rnum, 1)
        Next
        getRandomString = s
    End Function



    ' From http://www.codeproject.com/dotnet/ContentType.asp
    Public Function GetMIMEType(ByVal filepath As String) As String
        Dim regPerm As RegistryPermission = New RegistryPermission(RegistryPermissionAccess.Read, "\\HKEY_CLASSES_ROOT")
        Dim classesRoot As RegistryKey = Registry.ClassesRoot
        Dim fi = New FileInfo(filepath)
        Dim dotExt As String = LCase(fi.Extension)
        Dim typeKey As RegistryKey = classesRoot.OpenSubKey("MIME\Database\Content Type")
        Dim keyname As String

        GetMIMEType = ""
        For Each keyname In typeKey.GetSubKeyNames()
            Dim curKey As RegistryKey = classesRoot.OpenSubKey("MIME\Database\Content Type\" & keyname)
            If LCase(curKey.GetValue("Extension")) = dotExt Then
                GetMIMEType = keyname
            End If
        Next
    End Function

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        AddItem()
        row += 1
        LoadRow(row)
    End Sub
    'Not used. Hidden.
    Private Sub btnFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFiles.Click
        If dlgFiles.ShowDialog() = Windows.Forms.DialogResult.OK Then
            listFiles.Items.Add(dlgFiles.FileName)
        End If
    End Sub
    Private Sub btnProcessFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProcessFile.Click
        ProcessFile()
    End Sub

    Private Sub btnSkip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSkip.Click
        row += 1
        LoadRow(row)
    End Sub

    Private Sub btnHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHelp.Click
        Help.Show() 'Lame.
    End Sub

    Private Sub btnLogOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogOn.Click
        Logon()
    End Sub

    Private Sub txtRow_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtRow.KeyDown
        If Val(e.KeyCode) = 13 Then
            row = txtRow.Text
            LoadRow(row)
        End If
    End Sub

    Private Sub btnAddAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddAll.Click
        While rows(row, 0) <> ""
            AddItem()
            row += 1
            LoadRow(row)
        End While
    End Sub
End Class
